SystemOrganization addCategory: #'SourceCity-Tools'!

Object subclass: #CityVisualization
	instanceVariableNames: 'buildingGap buildingHighColor buildingLowColor buildingMaxHeightColor buildingMaxWidthColor cameraXPos cameraYPos cameraZPos cityColor districtColor districtGap glBackground listPackages openGL win model buildingMediumHeightColor buildingMediumColor glCity configurationClass unselectedSelectionList unselectedItems unselectedSelectionIndex selectedSelectionList selectedItems selectedSelectionIndex buildingHeightCalcList buildingWidthCalcList glAAList glPerspectiveList'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'SourceCity-Tools'!

!CityVisualization commentStamp: '<historical>' prior: 0!
A CityVisualization is the class who you use to configure the parameters of your draw 3D visualization, pakcage which you enter.!

!CityVisualization methodsFor: 'action-List' stamp: 'DouailleErwan 5/3/2012 11:14'!
addAllButtonAction
	self addAllItems.! !

!CityVisualization methodsFor: 'action-List' stamp: 'DouailleErwan 5/3/2012 10:39'!
addAllButtonState
	^false! !

!CityVisualization methodsFor: 'action-List' stamp: 'DouailleErwan 5/7/2012 10:40'!
addAllItems
	self selectedItems addAll: self unselectedItems.
	self unselectedItems removeAll.
	unselectedSelectionList removeAll.
	self unselectedSelectionIndex: 0.
	self
		changed: #selectedItems;
		changed: #hasSelectedItems;
		changed: #hasSelectedSelections;
		changed: #unselectedItems;
		changed: #hasUnselectedItems.! !

!CityVisualization methodsFor: 'action-List' stamp: 'DouailleErwan 5/3/2012 11:14'!
addButtonAction
	self addSelectedItems.! !

!CityVisualization methodsFor: 'action-List' stamp: 'DouailleErwan 5/3/2012 10:53'!
addButtonState
	^false! !

!CityVisualization methodsFor: 'action-List' stamp: 'DouailleErwan 5/7/2012 10:40'!
addSelectedItems

	self selectedItems addAll: self unselectedSelectionItems..
	self unselectedItems removeAll:  self unselectedSelectionItems..
	unselectedSelectionList removeAll.
	self selectedSelectionIndex: 0.
	self
		changed: #selectedItems;
		changed: #hasSelectedItems;
		changed: #hasSelectedSelections;
		changed: #unselectedItems;
		changed: #hasUnselectedItems.! !

!CityVisualization methodsFor: 'action-List' stamp: 'DouailleErwan 5/3/2012 10:38'!
buildAddAllButton
	^(win
		newButtonFor: self
		getState: #addAllButtonState
		action: #addAllButtonAction 
		arguments: nil
		getEnabled: #hasUnselectedItems
		label: '>>'
		help: nil)
		hResizing: #spaceFill! !

!CityVisualization methodsFor: 'action-List' stamp: 'DouailleErwan 5/3/2012 10:54'!
buildAddButton
	^(win
		newButtonFor: self
		getState: #addButtonState
		action: #addButtonAction 
		arguments: nil
		getEnabled: #hasUnselectedSelections
		label: '>'
		help: nil)
		hResizing: #spaceFill! !

!CityVisualization methodsFor: 'action-List' stamp: 'DouailleErwan 5/3/2012 11:09'!
buildRemoveAllButton
	^(win
		newButtonFor: self
		getState: #removeAllButtonState
		action: #removeAllButtonAction
		arguments: nil
		getEnabled: #hasSelectedItems
		label: '<<'
		help: nil)
		hResizing: #spaceFill! !

!CityVisualization methodsFor: 'action-List' stamp: 'DouailleErwan 5/3/2012 11:09'!
buildRemoveButton
	^(win
		newButtonFor: self
		getState: #removeButtonState
		action: #removeButtonAction 
		arguments: nil
		getEnabled: #hasSelectedSelections
		label: '<'
		help: nil)
		hResizing: #spaceFill! !

!CityVisualization methodsFor: 'selectedList' stamp: 'DouailleErwan 5/3/2012 11:13'!
buildSelectedItemsList
	^(PluggableListMorph
		on: self 
		list: #selectedItems
		primarySelection: #selectedSelectionIndex
		changePrimarySelection: #selectedSelectionIndex:
		listSelection: #selectedSelectionAt:
		changeListSelection: #selectedSelectionAt:put:
		menu: nil)
			hResizing: #spaceFill;
			vResizing: #spaceFill.! !

!CityVisualization methodsFor: 'unselectedList' stamp: 'DouailleErwan 5/3/2012 11:12'!
buildUnselectedItemsList
	^(PluggableListMorph
		on: self 
		list: #unselectedItems
		primarySelection: #unselectedSelectionIndex
		changePrimarySelection: #unselectedSelectionIndex:
		listSelection: #unselectedSelectionAt:
		changeListSelection: #unselectedSelectionAt:put:
		menu: nil)
			hResizing: #spaceFill;
			vResizing: #spaceFill.! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwans 5/2/2012 10:08'!
buildingGap
	^ buildingGap! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
buildingGap: anObject
	
	buildingGap := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 5/4/2012 10:59'!
buildingHeightCalcList
	^ buildingHeightCalcList! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 5/4/2012 10:59'!
buildingHeightCalcList: anObject
	buildingHeightCalcList := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
buildingHighColor
	
	^ buildingHighColor! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
buildingHighColor: anObject
	
	buildingHighColor := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
buildingLowColor
	
	^ buildingLowColor! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
buildingLowColor: anObject
	
	buildingLowColor := anObject! !

!CityVisualization methodsFor: 'action-CityConfiguration' stamp: 'StephaneDucasse 5/14/2012 15:27'!
buildingMaxHeightCalcColor: anObject
	((self buildingHeightCalcList selectedItem asSymbol) asString = 'none')
	ifTrue: [
		^ (anObject).
		] 
	ifFalse: [
		^ (anObject perform: (self buildingHeightCalcList selectedItem asSymbol))*2.
		].! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
buildingMaxHeightColor
	
	^ buildingMaxHeightColor! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 5/7/2012 12:50'!
buildingMaxHeightColor: anObject
		buildingMaxHeightColor := (anObject)! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
buildingMaxWidthColor
	
	^ buildingMaxWidthColor! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 5/7/2012 12:44'!
buildingMaxWidthColor: anObject
	buildingMaxWidthColor:= anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/26/2012 10:41'!
buildingMediumColor
	
	^ buildingMediumColor! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 5/7/2012 12:44'!
buildingMediumColor: anObject
	buildingMediumColor := anObject! !

!CityVisualization methodsFor: 'action-CityConfiguration' stamp: 'StephaneDucasse 5/14/2012 15:28'!
buildingMediumHeightCalcColor: anObject
	((self buildingHeightCalcList selectedItem asSymbol) asString = 'none')
	ifTrue: [
		^ (anObject).
		] 
	ifFalse: [
		^ (anObject perform: (self buildingHeightCalcList selectedItem asSymbol))*2.
		].! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/26/2012 10:40'!
buildingMediumHeightColor
	
	^ buildingMediumHeightColor! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 5/7/2012 12:50'!
buildingMediumHeightColor: anObject
		buildingMediumHeightColor := (anObject).
	! !

!CityVisualization methodsFor: 'displaying' stamp: 'DouailleErwan 5/7/2012 12:32'!
buildingTab
		^(win newRow:{
				win newGroupbox: 'Color settings' forAll:{
					(win newTitle: 'Low color' for: (((buildingLowColor) minHeight: 80; minWidth: 120))).
					(win newTitle: 'Medium color' for: (((buildingMediumColor) minHeight: 80; minWidth: 120))).
					(win newTitle: 'High color' for: ((buildingHighColor) minHeight: 80; minWidth: 120))
					}.
				win newGroupbox: 'Value settings' forAll:{
					(win newTitle: 'Gap between each building' for: (
						(win newTextEntryFor:  (buildingGap)
							getText: #contents 
							setText:  #contents:
							help: 'insert an Integer'))).
					(win newTitle: 'Medium selector size by building' for: (
						(win newTextEntryFor:  (buildingMediumHeightColor)
							getText: #contents 
							setText:  #contents:
							help: 'insert an Integer'))).
					(win newTitle: 'Max selector size by building' for: (
						(win newTextEntryFor:  (buildingMaxHeightColor)
							getText: #contents 
							setText:  #contents:
							help: 'insert an Integer'))).
				}.
				win newGroupbox: 'Size settings' forAll:{
					(win newTitle: 'Building height calculator' for: (
						(win newDropListFor: (buildingHeightCalcList)
							list: #list 
							getSelected: #selectionIndex 
							setSelected: #selectionIndex: 
							help: 'Method of calcul for better visualization'))).
					(win newTitle: 'Building width calculator' for: (
						(win newDropListFor: (buildingWidthCalcList)
							list: #list 
							getSelected: #selectionIndex 
							setSelected: #selectionIndex: 
							help: 'Method of calcul for better visualization'))).
				}.
			})! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 5/4/2012 10:59'!
buildingWidthCalcList
	^ buildingWidthCalcList! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 5/4/2012 10:59'!
buildingWidthCalcList: anObject
	buildingWidthCalcList := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
cameraXPos
	
	^ cameraXPos! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
cameraXPos: anObject
	
	cameraXPos := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
cameraYPos
	
	^ cameraYPos! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
cameraYPos: anObject
	
	cameraYPos := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
cameraZPos
	
	^ cameraZPos! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
cameraZPos: anObject
	
	cameraZPos := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
cityColor
	
	^ cityColor! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
cityColor: anObject
	
	cityColor := anObject! !

!CityVisualization methodsFor: 'action-CityConfiguration' stamp: 'DouailleErwan 5/22/2012 15:42'!
cityConfigurationBuild
	|config tmp |
	tmp := CityImporter new.
	tmp cityNamed: 'CodCT' withPackageNames: (self selectedItems) widthSelectorChoice: (self buildingWidthCalcList selectedItem asSymbol) heightSelectorChoice: (self buildingHeightCalcList selectedItem asSymbol) colorMediumSelector: self buildingMediumHeightColor contents asInteger colorHighSelector: self buildingMaxHeightColor contents asInteger colorLow: self buildingLowColor selectedColor colorMedium: self buildingMediumColor selectedColor colorHigh: self buildingHighColor selectedColor.
	self model: tmp.
	config := CityConfiguration new.
	^config cityColor: self cityColor selectedColor;
		districtColor: self districtColor selectedColor;
		districtGap: self districtGap contents asInteger;
		buildingLowColor: self buildingLowColor selectedColor;
		buildingMediumColor: self buildingMediumColor selectedColor;	
		buildingHighColor: self buildingHighColor selectedColor;	
		buildingGap: self buildingGap contents asInteger;
		buildingMediumHeightColor: (self buildingMediumHeightCalcColor: (self buildingMediumHeightColor contents asInteger));
		buildingMaxHeightColor: (self buildingMaxHeightCalcColor: (self buildingMaxHeightColor contents asInteger));
		buildingMaxWidthColor: self buildingMaxWidthColor contents asInteger;
		buildingHeightCalcList: self buildingHeightCalcList selectedItem asString;
		buildingWidthCalcList: self buildingWidthCalcList selectedItem asString;
		glBackground: self glBackground selectedColor ;
		glAAList: self glAAList selectedItem asString;
		glPerspectiveList: self glPerspectiveList selectedItem asString;
		cameraXPos: self cameraXPos contents asInteger;
		cameraYPos: self cameraYPos contents asInteger;
		cameraZPos: self cameraZPos contents asInteger;
		model: self model.! !

!CityVisualization methodsFor: 'displaying' stamp: 'DouailleErwan 5/4/2012 10:07'!
cityTab
		^(win newTitle: 'City color' for: (
				(cityColor) minHeight: 80; minWidth: 120;vResizing: #spaceFill))! !

!CityVisualization methodsFor: 'displaying' stamp: 'DouailleErwan 5/3/2012 09:52'!
components
	^(win newTabGroup: {
			(win newRow: {
				win newImage: PharoTheme newDefault smallConfigurationIcon . 
				win newLabel: 'Importer configuration'	})->
				(win newGroupbox: 'Select packages to visualize' forAll: { self packageTab}).
				'City settings'->(self cityTab).
				'Districts settings'->(self districtTab).
				'Buildings settings'->(self buildingTab).
				'OpenGL view settings'->(self openGLTab).
				})
			! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/27/2012 16:08'!
configurationClass

	^ CityConfiguration! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 5/11/2012 16:23'!
configurationClass1
	^ configurationClass! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/27/2012 14:51'!
configurationClass: aClass

	configurationClass := aClass! !

!CityVisualization methodsFor: 'displaying' stamp: 'DouailleErwan 5/24/2012 16:52'!
display
	|dock container |
		dock := win newToolDockingBar.
		dock
			addMorph: self toolbar.
			
		container := PanelMorph new.
		container 
			changeTableLayout; 
			listDirection: #rigthToLeft.
		container addMorph: self components.
		win
			addMorph: dock
			fullFrame: (LayoutFrame fractions: (0@0 corner: 1@0) offsets: (0@0 corner: 0 @ dock minExtent y));
			addMorph: container
			fullFrame: (LayoutFrame fractions: (0@0 corner: 1@1) offsets: (0@dock minExtent y corner: 0 @ 0)).
		win
			themeChanged;
			title: 'SourceCity Configuration';
			openInWorld;
			width: 800;
			height: 500.! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
districtColor
	
	^ districtColor! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
districtColor: anObject
	
	districtColor := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
districtGap
	
	^ districtGap! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
districtGap: anObject
	
	districtGap := anObject! !

!CityVisualization methodsFor: 'displaying' stamp: 'DouailleErwans 5/2/2012 10:14'!
districtTab
		^(win newRow:{
				win newGroupbox: 'Color settings' forAll:{
						(win newTitle: 'District color' for: ((districtColor) minHeight: 80; minWidth: 120)).
					}.
				win newGroupbox: 'Size settings' forAll:{
						(win newTitle: 'Gap between each district' for: (
							(win newTextEntryFor:  (districtGap)
								getText: #contents 
								setText:  #contents:
								help: 'insert an Integer'))).
					}
				})! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 5/11/2012 16:23'!
glAAList
	^ glAAList! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 5/11/2012 16:23'!
glAAList: anObject
	glAAList := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
glBackground
	
	^ glBackground! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
glBackground: anObject
	
	glBackground := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 5/11/2012 16:23'!
glCity
	^ glCity! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 5/11/2012 16:23'!
glCity: anObject
	glCity := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 5/11/2012 16:23'!
glPerspectiveList
	^ glPerspectiveList! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 5/11/2012 16:23'!
glPerspectiveList: anObject
	glPerspectiveList := anObject! !

!CityVisualization methodsFor: 'selectedList' stamp: 'DouailleErwan 5/3/2012 11:08'!
hasSelectedItems
	"Answer whether the selected list has items."

	^self selectedItems notEmpty! !

!CityVisualization methodsFor: 'selectedList' stamp: 'DouailleErwan 5/3/2012 11:08'!
hasSelectedSelections
	"Answer whether the selected list has selected items."

	^selectedSelectionList anySatisfy: [:selected | selected]! !

!CityVisualization methodsFor: 'unselectedList' stamp: 'DouailleErwan 5/3/2012 10:07'!
hasUnselectedItems
	^self unselectedItems notEmpty! !

!CityVisualization methodsFor: 'unselectedList' stamp: 'DouailleErwan 5/3/2012 10:11'!
hasUnselectedSelections
	"Answer whether the unselected list has selected items."

	^unselectedSelectionList anySatisfy: [:selected | selected]! !

!CityVisualization methodsFor: 'displaying' stamp: 'DouailleErwan 4/24/2012 11:33'!
helpDisplay
	|dialog builder window|
	window := UITheme .
	builder := window exampleBuilder.
	dialog := (builder newPluggableDialogWindow: 'Help !!') useDefaultOKButton.
	dialog contentMorph: (
		(dialog newRow: {
				(dialog newTextEditorFor: (ValueHolder new contents: 'SourceCity Information',Character cr asString,'Shortcut keyboard :') 
				getText: #contents 
				setText: #contents:) minWidth: 300;minHeight: 600;disable .
			})vResizing: #spaceFill); model: nil.
	builder openModal: dialog! !

!CityVisualization methodsFor: 'initialize-release' stamp: 'DouailleErwan 5/23/2012 22:41'!
initialize
	|tmp|
	tmp :=OrderedCollection new.
	tmp addAll: ((RPackageOrganizer default packageNames) sort: [:a :b | a name < b name]).
	self unselectedItems: OrderedCollection new.
	self selectedItems: tmp.
	selectedSelectionList := Dictionary new.
	unselectedSelectionList := Dictionary new.
	win := StandardWindow new.
	cityColor := win newHSVSelector: (Color r: 0.6 g: 0.6 b: 0.6) 
		help: 'This is a hue-saturation-volume selector'.
	districtColor := win newHSVSelector: (Color r: 0.8 g: 0.8 b: 0.8)
		help: 'This is a hue-saturation-volume selector'.
	districtGap := ValueHolder new contents: '2'.
	buildingLowColor := win newHSVSelector: (Color green)
		help: 'This is a hue-saturation-volume selector'.
	buildingMediumColor := win newHSVSelector: (Color  orange)
		help: 'This is a hue-saturation-volume selector'.
	buildingHighColor := win newHSVSelector: (Color  red)
		help: 'This is a hue-saturation-volume selector'.
	buildingGap := ValueHolder new contents: '2'.
	buildingMediumHeightColor := ValueHolder new contents: '20'.
	buildingMaxHeightColor := ValueHolder new contents: '50'.
	buildingMaxWidthColor := ValueHolder new contents: '5'.
	buildingHeightCalcList := ListModel new list: #('sqrt' 'ln' 'log' 'none');selectionIndex:2.
	buildingWidthCalcList := ListModel new list: #('sqrt' 'ln' 'log' 'none');selectionIndex:2.
	glBackground := win newHSVSelector: (Color r: 1 g: 1 b: 1)
		help: 'This is a hue-saturation-volume selector'.
	glAAList := ListModel new list: #('FASTEST' 'NICEST');selectionIndex:1.
	glPerspectiveList := ListModel new list: #('FASTEST' 'NICEST');selectionIndex:1.
	cameraXPos := ValueHolder new contents: '-196'.
	cameraYPos := ValueHolder new contents: '-15'.
	cameraZPos := ValueHolder new contents: '0'.
	self display! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
listPackages
	
	^ listPackages! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
listPackages: anObject
	
	listPackages := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 09:57'!
model
	^ model! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 09:57'!
model: anObject
	model := anObject! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:50'!
openGL
	
	^ openGL! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
openGL: anObject
	
	openGL := anObject! !

!CityVisualization methodsFor: 'displaying' stamp: 'DouailleErwan 5/24/2012 15:18'!
openGLTab
		^(win newRow:{
				win newGroupbox: 'Color settings' forAll:{
					(win newTitle: 'Background color' for: ((glBackground) minHeight: 80; minWidth: 120)).}.
					win newGroupbox: 'Camera default position settings' forAll:{
					(win newTitle: 'x' for: (
						(win newTextEntryFor:  (cameraXPos)
							getText: #contents
							setText:  #contents:
							help: 'insert an Integer'))).
					(win newTitle: 'y' for: (
						(win newTextEntryFor:  (cameraYPos)
							getText: #contents 
							setText:  #contents:
							help: 'insert an Integer'))).
					(win newTitle: 'z' for: (
						(win newTextEntryFor:  (cameraZPos)
							getText: #contents 
							setText:  #contents:
							help: 'insert an Integer'))).
				}.
				win newGroupbox: 'OpenGL environment settings DO NOT WORK' forAll:{
					(win newTitle: 'Enable/disable Light' for: (
						(win newCheckboxFor: (ValueHolder new contents: true)
						getSelected: #contents setSelected: #contents: label: 'Light' help: 'This is a checkbox'))).
					(win newTitle: 'Enable/disable Light' for: (
						(win newCheckboxFor: (ValueHolder new contents: true)
						getSelected: #contents setSelected: #contents: label: 'Shadow' help: 'This is a checkbox'))).
					(win newTitle: 'Anti analysing performance' for: (
						(win newDropListFor: (glAAList)
							list: #list 
							getSelected: #selectionIndex 
							setSelected: #selectionIndex: 
							help: 'Method of calcul for better visualization'))).
					(win newTitle: 'Perspective performance' for: (
						(win newDropListFor: (glPerspectiveList)
							list: #list 
							getSelected: #selectionIndex 
							setSelected: #selectionIndex: 
							help: 'Method of calcul for better visualization'))).
					}
				})! !

!CityVisualization methodsFor: 'displaying' stamp: 'DouailleErwan 5/4/2012 10:08'!
packageTab
		^(win newRow:{
				win newGroupbox: 'Unselected packages' for: (win newColumn: {
						self buildUnselectedItemsList.}).
				(win newGroupboxFor: (
					(win newColumn: {
						self buildAddAllButton.
						self buildAddButton.
						self buildRemoveButton.
						self buildRemoveAllButton})
						vResizing: #shrinkWrap))
					vResizing: #shrinkWrap.
				win newGroupbox: 'Selected packages' for: (win newColumn: {
						self buildSelectedItemsList.}).
				})vResizing: #spaceFill;hResizing: #spaceFill! !

!CityVisualization methodsFor: 'action-CityConfiguration' stamp: 'DouailleErwan 4/26/2012 11:04'!
refreshActivity
	(glCity isNil)
	ifFalse: [
		glCity changeConfiguration: self cityConfigurationBuild.
		].
	! !

!CityVisualization methodsFor: 'action-List' stamp: 'DouailleErwan 5/3/2012 11:14'!
removeAllButtonAction
	self removeAllItems.! !

!CityVisualization methodsFor: 'action-List' stamp: 'DouailleErwan 5/3/2012 11:09'!
removeAllButtonState
	^false! !

!CityVisualization methodsFor: 'action-List' stamp: 'DouailleErwan 5/7/2012 10:40'!
removeAllItems
	self unselectedItems addAll: self selectedItems.
	self selectedItems removeAll.
	selectedSelectionList removeAll.
	self selectedSelectionIndex: 0.
	self
		changed: #selectedItems;
		changed: #hasSelectedItems;
		changed: #hasSelectedSelections;
		changed: #unselectedItems;
		changed: #hasUnselectedItems.! !

!CityVisualization methodsFor: 'action-List' stamp: 'DouailleErwan 5/3/2012 11:13'!
removeButtonAction
	self removeSelectedItems.! !

!CityVisualization methodsFor: 'action-List' stamp: 'DouailleErwan 5/3/2012 11:09'!
removeButtonState
	^false! !

!CityVisualization methodsFor: 'action-List' stamp: 'DouailleErwan 5/7/2012 10:40'!
removeSelectedItems
	self unselectedItems addAll:  self selectedSelectionItems..
	self selectedItems removeAll: self selectedSelectionItems..
	selectedSelectionList removeAll.
	self selectedSelectionIndex: 0.
	self
		changed: #selectedItems;
		changed: #hasSelectedItems;
		changed: #hasSelectedSelections;
		changed: #unselectedItems;
		changed: #hasUnselectedItems.! !

!CityVisualization methodsFor: 'selectedList' stamp: 'DouailleErwan 5/3/2012 10:56'!
selectedItems
	^selectedItems! !

!CityVisualization methodsFor: 'selectedList' stamp: 'DouailleErwan 5/3/2012 10:56'!
selectedItems: anOrderedCollection 
	
	selectedItems := anOrderedCollection.! !

!CityVisualization methodsFor: 'selectedList' stamp: 'DouailleErwan 5/3/2012 11:02'!
selectedSelectionAt: index

	^selectedSelectionList at: index ifAbsent: [false]! !

!CityVisualization methodsFor: 'selectedList' stamp: 'DouailleErwan 5/3/2012 11:02'!
selectedSelectionAt: index put: aBoolean
	"Mark the item as selected or not."
	
	selectedSelectionList at: index put: aBoolean.
	self changed: #hasSelectedSelections! !

!CityVisualization methodsFor: 'selectedList' stamp: 'DouailleErwan 5/3/2012 11:00'!
selectedSelectionIndex
	selectedSelectionIndex ifNil: [selectedSelectionIndex := 0].
	^selectedSelectionIndex! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 5/11/2012 16:23'!
selectedSelectionIndex1
	^ selectedSelectionIndex! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 5/11/2012 16:23'!
selectedSelectionIndex1: anObject
	^ selectedSelectionIndex := anObject! !

!CityVisualization methodsFor: 'selectedList' stamp: 'DouailleErwan 5/3/2012 11:00'!
selectedSelectionIndex: anObject

	selectedSelectionIndex := anObject.
	self changed: #selectedSelectionIndex! !

!CityVisualization methodsFor: 'selectedList' stamp: 'DouailleErwan 5/3/2012 11:19'!
selectedSelectionItems

	| result |
	result := OrderedCollection new.
	self selectedItems doWithIndex: [:item :index |
		(self selectedSelectionAt: index)
			ifTrue: [result add: item]].
	^result! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 5/11/2012 16:23'!
selectedSelectionList
	^ selectedSelectionList! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 5/11/2012 16:23'!
selectedSelectionList: anObject
	selectedSelectionList := anObject! !

!CityVisualization methodsFor: 'action-CityConfiguration' stamp: 'DouailleErwan 4/27/2012 16:07'!
startActivity
	glCity := GLCity new default: self cityConfigurationBuild ;openInWorld.! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:08'!
test
	^'youhou'! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/25/2012 15:07'!
test: anObject
	Transcript cr;show:anObject.! !

!CityVisualization methodsFor: 'displaying' stamp: 'DouailleErwan 4/26/2012 11:23'!
toolbar
	^win newToolbar: {
		win newButtonFor: self 
			getState:  nil
			action:  #startActivity
			arguments:  nil
			getEnabled:  nil
			labelForm:  win theme smallDoItIcon 
			help:'Start City view' .
		win newButtonFor: self 
			getState:  nil
			action:  #refreshActivity
			arguments:  nil
			getEnabled:  nil
			labelForm:  win theme smallUpdateIcon 
			help:'Change current configuration' .
			}.! !

!CityVisualization methodsFor: 'unselectedList' stamp: 'DouailleErwan 5/3/2012 10:31'!
unselectedItems
	^unselectedItems! !

!CityVisualization methodsFor: 'unselectedList' stamp: 'DouailleErwan 5/3/2012 10:31'!
unselectedItems: anOrderedCollection 
	
	unselectedItems := anOrderedCollection.! !

!CityVisualization methodsFor: 'unselectedList' stamp: 'DouailleErwan 5/3/2012 13:29'!
unselectedSelectionAt: index

	^unselectedSelectionList at: index ifAbsent: [false]! !

!CityVisualization methodsFor: 'unselectedList' stamp: 'DouailleErwan 5/3/2012 13:29'!
unselectedSelectionAt: index put: aBoolean
	"Mark the item as selected or not."
	
	unselectedSelectionList at: index put: aBoolean.
	self changed: #hasUnselectedSelections! !

!CityVisualization methodsFor: 'unselectedList' stamp: 'DouailleErwan 5/3/2012 10:32'!
unselectedSelectionIndex
	unselectedSelectionIndex ifNil: [unselectedSelectionIndex := 0].
	^unselectedSelectionIndex! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 5/11/2012 16:23'!
unselectedSelectionIndex1
	^ unselectedSelectionIndex! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 5/11/2012 16:23'!
unselectedSelectionIndex1: anObject
	^ unselectedSelectionIndex := anObject! !

!CityVisualization methodsFor: 'unselectedList' stamp: 'DouailleErwan 5/3/2012 10:37'!
unselectedSelectionIndex: anObject

	unselectedSelectionIndex := anObject.
	self changed: #unselectedSelectionIndex! !

!CityVisualization methodsFor: 'unselectedList' stamp: 'DouailleErwan 5/3/2012 14:10'!
unselectedSelectionItems

	| result |
	result := OrderedCollection new.
	self unselectedItems doWithIndex: [:item :index |
		(self unselectedSelectionAt: index)
			ifTrue: [result add: item]].
	^result! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 5/11/2012 16:23'!
unselectedSelectionList
	^ unselectedSelectionList! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 5/11/2012 16:23'!
unselectedSelectionList: anObject
	unselectedSelectionList := anObject! !

!CityVisualization methodsFor: 'updating' stamp: 'DouailleErwan 4/26/2012 11:07'!
update: aSymbol 
	self refreshActivity! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
win
	
	^ win! !

!CityVisualization methodsFor: 'accessing' stamp: 'DouailleErwan 4/24/2012 16:26'!
win: anObject
	
	win := anObject! !
